/* $Id: tdsreg.h,v 1.1.1.1 2005/08/06 05:45:12 kiyohara Exp $ */

#ifndef _TDSREG_H
#define _TDSREG_H


/* Registers (write) */
#define	TDS_REG_WRITE_SAMPLING_START		0x00
#define	TDS_REG_WRITE_FIFO_CLEAR		0x01
#define	TDS_REG_WRITE_INTERRUPT_SET		0x04
#define	TDS_REG_WRITE_SAMPLING_SET		0x05
#define	TDS_REG_WRITE_SYNCRONIZE		0x06
#define	TDS_REG_WRITE_TIME_SET			0x08
#define	TDS_REG_WRITE_DMA_ADDR_SET		0x10
#define	TDS_REG_WRITE_DMA_SIZE_SET		0x14
#define	TDS_REG_WRITE_DMA_START			0x18
#define	TDS_REG_WRITE_DMA_MODE			0x19
#define TDS_REG_WRITE_CLEAR_WRITE_COUNTER	0x20
#define TDS_REG_WRITE_CLEAR_READ_COUNTER	0x24


/* Registers (read) */
#define	TDS_REG_READ_DATA			0x00
#define	TDS_REG_READ_INTERRUPT			0x04
#define	TDS_REG_READ_STATUS			0x06
#define	TDS_REG_READ_YEAR			0x07
#define	TDS_REG_READ_TIME			0x08
#define	TDS_REG_READ_INPUT			0x0c
#define	TDS_REG_READ_DMA_SIZE			0x14
#define	TDS_REG_READ_DMA_STATUS			0x18
#define	TDS_REG_READ_DMA_MODE			0x19
#define	TDS_REG_READ_WRITE_COUNTER		0x20
#define	TDS_REG_READ_READ_COUNTER		0x24


/* interrupt */
#define TDS_INTR_1PPS			(0x01 << 0)
#define TDS_INTR_DMA_DONE		(0x01 << 1)
#define TDS_INTR_DATA_EXIST		(0x01 << 3)
#define TDS_INTR_DATA_EMPTY		(0x01 << 4)
#define TDS_INTR_DATA_FULL		(0x01 << 5)
#define TDS_INTR_DATA_HALF		(0x01 << 6)

/* dma mode */
#define TDS_DMA_MODE_SOFT		(0x00 << 0)
#define TDS_DMA_MODE_HARD		(0x01 << 0)
#define TDS_DMA_MODE_RELATIVE		(0x00 << 1)
#define TDS_DMA_MODE_REWIND		(0x01 << 1)


/* buffer flags */
#define TDS_BUFFLAG_READ_WAIT		(0x01 << 0)
#define TDS_BUFFLAG_DATA_READY		(0x01 << 1)
#define TDS_BUFFLAG_WRITE_BUSY		(0x01 << 2)

/* Hardware internal FIFO size */
#define TDS_FIFO_SIZE		(0x01 << 20)		/* 1M(Byte) */

/* max data size on busmaster transfer */
/* For soft trriger mode */
#define TDS_DMA_MAX_WORD	0x20000		/* 128K words */
#define TDS_DMA_MAX_SIZE	(TDS_DMA_MAX_WORD * sizeof(uint32_t))

/* For hard trriger mode */
#define TDS_DMA_MIN_CHUNK	0x00400		/*  1K words */
#ifndef	TDS_COMPAT_VLBI111
#define TDS_DMA_MAX_CHUNK	0x20000		/* 128K words */

#define TDS_DMA_SIZE	(TDS_DMA_MAX_CHUNK * sizeof(uint32_t))
#define	TDS_DMA_NSEG	16
#else /* TDS_COMPAT_VLBI111 */
#define TDS_DMA_MAX_CHUNK	0x10000		/* 64K words */

#define TDS_DMA_SIZE	TDS_FIFO_SIZE	/*(TDS_DMA_MAX_CHUNK * sizeof(uint32_t))*/
#define	TDS_DMA_NSEG	8
#endif /* TDS_COMPAT_VLBI111 */

#define	TDS_DMA_USE_CHUNK	0		/* dynamic */


#define TDSPRI		(PZERO - 1)
#define spltds()	spltty()
#define INTR_TYPE_TDS	INTR_TYPE_TTY


#define TDS_MAX_FIFO_OVERFLOW_DEFAULT	16
#define TDS_SAMPLING_DEFAULT	\
	(TDS_SAMPLING_40KHZ | TDS_SAMPLING_1BIT | TDS_SAMPLING_1CH)


/* FIFO counter */
#define TDS_FIFO_COUNTER_MAX    0x40000000
#define TDS_FIFO_COUNTER_MASK   0x3fffffff
#define TDS_FIFO_COUNTER_CLEAR  0x01


/* DMA control */
#define	TDS_DMA_START	0x01
#define	TDS_DMA_STOP	0x00

/* DMA status */
#define TDS_DMA_STATUS	0x01



#define TDS_TURN_ARROUND_MIN	100
#define TDS_TURN_ARROUND_MAX	4000

#endif	/* _TDSREG_H */
